#include "uni1p_access.h"
#include <stdio.h>
#include <time.h>

#include <commdef.h>
#include "libUni1P.h"

#include "cv.h"
#include "highgui.h"
#include <ctype.h>

#define READ_SEC 4
#define WRITE_SEC 8
#define SEC_SIZE 1024
#define IN_PX_BYTE_C 1
#define OUT_PX_BYTE_C 2

#define SIZEX 1024
#define SIZEY 768

int Uni1pHpiWriteWord(  UNI1P_HANDLE hPlx,
                               tUni1pHpiModule dsp,
                               DWORD dest,
                               DWORD data)
{
  return Uni1pHpiBlock(hPlx, FALSE, dsp, dest, 1, &data);
}

DWORD Uni1pHpiReadWord(  UNI1P_HANDLE hPlx,
                                tUni1pHpiModule dsp,
                                DWORD src)
{
	DWORD buf[5] = { 0 };
  Uni1pHpiBlock(hPlx, TRUE, dsp, src, 1, buf);
  return buf[0];
}

/*
DWORD ReadDWord(P9054_HANDLE hPlx, DWORD addr)  {
    return P9054_ReadDWord(hPlx,
                    (addr & ADDR_SPACE_MASK) == CPLD_BASE_ADDR? CPLD_ADDR_SPACE : FPGA_ADDR_SPACE,
                    addr & ~ADDR_SPACE_MASK);
}


void WriteDWord(P9054_HANDLE hPlx, DWORD addr, DWORD data)  {
    P9054_WriteDWord(hPlx,
                    (addr & ADDR_SPACE_MASK) == CPLD_BASE_ADDR? CPLD_ADDR_SPACE : FPGA_ADDR_SPACE,
                    addr & ~ADDR_SPACE_MASK,
                    data);
}


*/
int main (int argc, char *argv[])
{
        UNI1P_HANDLE hPlx;
		int i;
		int             j, k, block;
		int RetCode;
//		tUni1pHpiStatus HpiStatus;
		unsigned long result=0;
		unsigned long buf = 0;

		unsigned long status=0;

		FILE            *f;
		long            size;   // size buffer in bytes
	    BYTE            *data;
	    BYTE            *partdata;
		
		unsigned long	start_in_data;//4B
		unsigned long	start_out_data;//4B
		unsigned long *poleptr;//4B
		
    DWORD           fpga = 0;
	DWORD stat;
		
		double runsec, runsecavg;
		double sumsec, sumseceavg;
		double commsec, commsecavg;



		int runcnt;

	CvCapture* capture = 0;						// for video capture from webcam
	IplImage* source;							// pointer to image
	IplImage* grayimage;							// pointer to image
	IplImage* bigimage;							// pointer to image
	//int c;										// used for user input to capture "Esc" key
	//int step;
	//CvSize roisize;
	int x, y;
	int x0 = 0;
	int y0 = 0;


	uchar	*imagerawdata, *raw_data_ptr;


	uchar *img_data_in=NULL, *data_in_ptr;//1B

	unsigned long *img_data_out;//4B
	uchar *img_data_out_n;//1B
	unsigned short *pptr;

	unsigned long out_data_len=0;
	unsigned long out_min=0;
	unsigned long out_max=0;

	int i_part;


	double scale;

	clock_t start, stop;
	clock_t rstart, rstop;
	clock_t runstart, runstop;

	int c;										// used for user input to capture "Esc" key
	int aloc;



	if(argc<2 || argc>22){
		printf("Usage : %s <dsp_binary_file> [[<bitstream_0> <width_0>] ... [<bitstream_9> <width_9>]]\n", argv[0]);
		return 0;
	}

		// Initialize library
		Uni1pInit();
		//nastartovani komunikace s kartou
        hPlx = NULL;
        hPlx = Uni1pOpenBoard(0);

		if (hPlx)
        {
//			unsigned x;
                RetCode=Uni1pHpiInit(hPlx);
                Sleep(200);
			Sleep(200);
                fprintf( stderr, "Uni1pOpenBoard OK!\n");
        } else {
                fprintf( stderr, "Uni1pOpenBoard failed!\n");
        }



//        if ( ( f = fopen( "dspdemo\\dspdemo.bin", "rb" ) ) == NULL )  {
        if ( ( f = fopen( argv[1], "rb" ) ) == NULL )  {
            fprintf( stderr, "Can't open binary file\n");
            return -1;
        }
        // get file size
        fseek( f, 0, SEEK_END );
        size = ftell( f );
        fseek( f, 0, SEEK_SET );

        // alloc buffer
        if ( ( data = (BYTE*) malloc( size ) ) == NULL )  {
            fprintf( stderr, "Can't alloc enought memory!\n" );
            return -1;
        }
		// load file to memory
        if ( fread( data, 1, size, f ) != (size_t) size )  {
            fprintf( stderr, "Can't read file!\n" );
            return -1;
        }

		RetCode=Uni1pHpiDspReset(hPlx, UNI1P_DSP_M2);
		Sleep(200);
        if (Uni1pHpiBlock(hPlx, FALSE, UNI1P_DSP_M2, 0x0, (size)/4, (unsigned long *)data))
        {
                fprintf( stderr, "Uni1pHpiWriteBlock returned error!\n");
        }
        Sleep(200);
        Uni1pHpiDspRun(hPlx, UNI1P_DSP_M2);
        Sleep(200);


		fclose(f);


	/*********** Get capture from camera ***********/

    capture = cvCaptureFromCAM( 0 );
    
    if(!capture)
    {
        fprintf(stderr,"Could not initialize camera...\n");
        return -1;
    } 

	/*********** Create windows, autosize to images ***********/

    cvNamedWindow("Webcam", CV_WINDOW_AUTOSIZE);

	aloc=0;
	x = 1024;
	y = 768;

	runsec = 0;
	runsecavg = 0;
	sumsec = 0;
	sumseceavg = 0;
	commsec = 0;
	commsecavg = 0;
	runcnt = 1;

	for(;;){
		/*********** Capture image from camera ***********/
		start = clock();

		source = cvQueryFrame(capture);
		if( !source )
			return 1;


		scale = source->width/SIZEX;
		grayimage = cvCreateImage(cvSize(source->width, source->height), IPL_DEPTH_8U, 1);
		bigimage = cvCreateImage( cvSize( SIZEX, SIZEY), IPL_DEPTH_8U, 1 );
	 
		cvCvtColor( source, grayimage, CV_BGR2GRAY );
        cvFlip(grayimage, NULL, 0);

		cvResize(grayimage, bigimage, CV_INTER_LINEAR );


		//cvGetRawData( bigimage, (uchar**)&imagerawdata, &step, &roisize );
		imagerawdata = bigimage->imageDataOrigin;
		if(aloc==0){

			// alloc image input data buffer
//			if ( ( img_data_in = (uchar*) malloc( roisize.width * roisize.height * sizeof(uchar) ) ) == NULL )  {
			if ( ( img_data_in = (uchar*) malloc( (SIZEX+2) * SIZEY * sizeof(uchar) ) ) == NULL )  {
				printf("Can't alloc enought memory!\n" );
				return -1;
			}

			// alloc image output data buffer
//			if ( ( img_data_out = (unsigned long*) malloc( roisize.width * roisize.height * sizeof(unsigned long)/2 ) ) == NULL )  {
			if ( ( img_data_out = (unsigned long*) malloc( (SIZEX+2) * SIZEY * sizeof(unsigned long)/2 ) ) == NULL )  {
				printf("Can't alloc enought memory!\n" );
				return -1;
			}

			// alloc image normalized output data buffer
//			if ( ( img_data_out_n = (uchar*) malloc( roisize.width * roisize.height * sizeof(uchar) ) ) == NULL )  {
			if ( ( img_data_out_n = (uchar*) malloc( (SIZEX+2) * SIZEY * sizeof(uchar) ) ) == NULL )  {
				printf("Can't alloc enought memory!\n" );
				return -1;
			}

			aloc=1;
		}

		if((x0+x) > SIZEX) x0=0;
		if((y0+y) > SIZEY) y0=0;

		data_in_ptr = img_data_in;
		raw_data_ptr = imagerawdata + y0*SIZEX + x0;
		for(i=0; i<y; i++){
			for(j=0; j<x; j++){

				///add 0 at the begining of line
				if(j==0){
					*data_in_ptr = 0;
					*data_in_ptr++;
				}

				*data_in_ptr = *raw_data_ptr;
				*data_in_ptr++;
				*raw_data_ptr++;				

				///add 0 at the end of line
				if(j==x-1){
					*data_in_ptr = 0;
					*data_in_ptr++;
				}


			}
			raw_data_ptr += SIZEX - x;
		}

		//poleptr = (unsigned long *)imagerawdata;
		poleptr = (unsigned long *)img_data_in;
		i_part=0;
		start_in_data = Uni1pHpiReadWord(hPlx, UNI1P_DSP_M2, SOBEL_INPUT);
		start_out_data = Uni1pHpiReadWord(hPlx, UNI1P_DSP_M2, SOBEL_OUTPUT);

		//if (Uni1pHpiBlock(hPlx, FALSE, UNI1P_DSP_M2, start_in_data, (roisize.width * roisize.height)/(sizeof(unsigned long)), (unsigned long *)poleptr))
		//start = clock();
		if (Uni1pHpiBlock(hPlx, FALSE, UNI1P_DSP_M2, start_in_data, ((x+2) * y)/(sizeof(unsigned long)), (unsigned long *)poleptr))
		{
				printf("Uni1pHpiWriteBlock returned error!\n");
		}
		//stop = clock();

		//Uni1pHpiWriteWord(hPlx, UNI1P_DSP_M2, SOBEL_DATA_IN_LEN, (roisize.width * roisize.height));
		Uni1pHpiWriteWord(hPlx, UNI1P_DSP_M2, SOBEL_DATA_IN_LEN, ((x+2) * y));
		Uni1pHpiWriteWord(hPlx, UNI1P_DSP_M2, SOBEL_DATA_IN_READY, 1);
		

		runstart = clock();
		while( Uni1pHpiReadWord(hPlx, UNI1P_DSP_M2, SOBEL_DONE) != 1);
			//show last image
			//cvShowImage( "Webcam", bigimage);
		
		runstop = clock();
		runsec=((double)(runstop - runstart)/CLOCKS_PER_SEC);
		runsecavg += runsec;
		//printf("Time: %f s (Avg Time[/%d] %f s)\n", runsec, runcnt, runsecavg/runcnt);
		runcnt++;

		out_data_len = Uni1pHpiReadWord(hPlx, UNI1P_DSP_M2, SOBEL_DATA_OUT_LEN);

		//start = clock();
		//if (Uni1pHpiBlock(hPlx, TRUE, UNI1P_DSP_M2, start_out_data, (roisize.width * roisize.height * 2)/(sizeof(unsigned long)), img_data_out ))
		if (Uni1pHpiBlock(hPlx, TRUE, UNI1P_DSP_M2, start_out_data, ((x+2) * y * 2)/(sizeof(unsigned long)), img_data_out ))
		{
				printf("Uni1pHpiReadBlock returned error!\n");
		}
		//stop = clock();

	
		pptr = (unsigned short *)img_data_out;

//		for(i=0; i< (unsigned)(roisize.height * roisize.width); i++){
		for(i=0; i< ((x+2) * y); i++){
			img_data_out_n[i]=(uchar)((sqrt(*pptr)));
			//if((uchar)((sqrt(*pptr)))>30) img_data_out_n[i]=255;//(uchar)((sqrt(*pptr)));
			//else img_data_out_n[i]=0;

			pptr++;
		}

		//cvSetImageData(bigimage, img_data_out_n, step);

		if((x0+x) > SIZEX) x0=0;
		if((y0+y) > SIZEY) y0=0;

		data_in_ptr = img_data_out_n;
		raw_data_ptr = imagerawdata + y0*SIZEX + x0;
		for(i=0; i<y; i++){
			for(j=0; j<(x+2); j++){
				if(j==0 || j==(x+1)) {
					*data_in_ptr++;
				} else {

				*raw_data_ptr = *data_in_ptr;
				*data_in_ptr++;
				*raw_data_ptr++;				
				}
			}
			raw_data_ptr += SIZEX - x;
		}

		

		//cvResize(bigimage, grayimage, CV_INTER_LINEAR );
		cvShowImage( "Webcam", bigimage);


		/*********** Quit if user presses "Esc" ***********/
        c = cvWaitKey(1);
		//printf("KEY: %d\n", (char)c);
		if( (char)c == 27 ){
			cvSaveImage( "image.jpg", bigimage );
            break;
		}


		if( (char)c == 87 || (char)c == 119 ){ //W
            y0-=10;
			if(y0<0) y0=0;
		}

		if( (char)c == 83 || (char)c == 115 ){ //S
            y0+=10;
			if(y0+y >=SIZEY) y0=SIZEY - y;
		}


		if( (char)c == 65 || (char)c == 97 ){ //A
            x0-=10;
			if(x0<0) x0=0;
		}

		if( (char)c == 68 || (char)c == 100 ){ //D
            x0+=10;
			if(x0+x >=SIZEX) x0=SIZEX - x;
		}


		if( (char)c == 43 ){ //+
            y+=10;			
			if(y>SIZEY) y=SIZEY;
		}

		if( (char)c == 45 ){ //-
            y-=10;			
			if(y<3) y=3;
		}

		//Uni1pWriteDWord( hPlx, SYSTEM_SMAP_STAT, fpga );
		
		if( (char)c >= 48 && (char)c <= (57-(10-((argc-2)/2))) && argc>2){//0..9
			if ( ( f = fopen( argv[(((char)c-48)*2)+2], "rb" ) ) == NULL )  {
				printf( "Can't open file: %s\n", argv[(((char)c-48)*2)+2] );
                return -1;
            }

			printf( "Loading bitstream: %s\n", argv[(((char)c-48)*2)+2] );
			

			x=atoi(argv[(((char)c-48)*2)+2 + 1]);//1024;
			y=x*SIZEY/SIZEX;
			x0=0;
			y0=0;

			printf("Image size: %dx%d px\n", x, y);

			runsec = 0;
			runsecavg = 0;
			sumsec = 0;
			sumseceavg = 0;
			commsec = 0;
			commsecavg = 0;
			runcnt = 1;


			fpga = 0x10;//M2
            // get file size
            fseek( f, 0, SEEK_END );
            size = ftell( f );
            fseek( f, 0, SEEK_SET );

            // alloc buffer
            if ( ( partdata = (BYTE*) malloc( size ) ) == NULL )  {
               fprintf( stderr, "Can't alloc enought memory!\n" );
               return -1;
            }

            // load file to memory
            if ( fread( partdata, 1, size, f ) != (size_t) size )  {
               fprintf( stderr, "Can't read file!\n" );
               return -1;
            }

			rstart = clock();

            Uni1pWriteDWord( hPlx, SYSTEM_SMAP_STAT, fpga );
            k = 0;
            size = (size + 3) / 4;
            while ( size > 0 )  {
                stat = Uni1pReadDWord( hPlx, SYSTEM_SMAP_STAT );
                block = 15 - ((stat >> 16) & 0xf);
                if ( block > size ) block = size;

                for ( j = 0; j < block; j ++ )  {
                    Uni1pWriteDWord( hPlx, SYSTEM_SMAP_DATA, ((DWORD *)partdata)[ k ++ ] );
                }
                size -= block;
            }
			
			Uni1pWriteDWord( hPlx, SYSTEM_SMAP_DATA, 0x20000000 ); //configuration interface  NOP to prevent Virtex II configuration "bug"

            fpga = 0;
            Uni1pWriteDWord( hPlx, SYSTEM_SMAP_STAT, fpga );

			rstop = clock();
			printf("Reconfiguration time : %ld ticks.\n", (rstop - rstart));
				
			fclose(f);
			printf("OK\n");

		}//bitstram select

		//cvReleaseImage(&source);
		cvReleaseImage(&grayimage);
		cvReleaseImage(&bigimage);

		stop = clock();
		//printf("Size: %ld B; Time: %f s; Rate: %f B/s\n", (x * y * 2)/(sizeof(unsigned long)),((double)(stop - start)/CLOCKS_PER_SEC), ((x * y * 2)/(sizeof(unsigned long)))/(((double)(stop - start)/CLOCKS_PER_SEC)));

		sumsec = ((double)(stop - start)/CLOCKS_PER_SEC);
		sumseceavg += sumsec;
		commsec = sumsec - runsec;
		commsecavg += commsec;
		//printf("[%d] Sum Time: %f s; Run Time %f s, Comm Time %f s\n",runcnt, sumseceavg/runcnt, runsecavg/runcnt, commsecavg/runcnt);

    }


	
	//cvSaveImage( "img_edge.jpg", bigimage );
	/*********** Display image in appropriate window ***********/
	//cvShowImage( "Webcam", grayimage);
	//cvSaveImage( "img_gray.jpg", grayimage );
	//cvSaveImage( "image.jpg", source );


	free(data);
	free(img_data_out);
	free(img_data_out_n);
	free(img_data_in);
    cvReleaseCapture( &capture );
    cvDestroyAllWindows();

	//fclose(fpokus);


}
//---------------------------------------------------------------------------






