---------------------------------------------------------------------------------------------
-- Package:	 	MathLib
-- Project:		Uni1P
-- Author:		Antonin Hegar
--
-- Description:
--
-- Version:
--  $Log: math_lib.vhd,v $
--  Revision 1.1  2004/12/06 23:20:05  Tony
--  Initial version.
--
--
-- Restriction:
---------------------------------------------------------------------------------------------


---------------------------------------------------------------------------------------------
-- LIBRARIES
---------------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

---------------------------------------------------------------------------------------------
-- PACKAGE HEAD
---------------------------------------------------------------------------------------------
package MathLib is

	---------------------------------------------------------------------------------------
	-- log2(n)
	--  function returns how many bits is neccesary to show value n
	function log2 ( n : natural ) return natural;

	---------------------------------------------------------------------------------------
	-- min(a, b)
	--  function returns lowest from values a and b
	function min ( a, b : natural ) return natural;

	---------------------------------------------------------------------------------------
	-- max(a, b)
	--  function returns bigger from values a and b
	function max ( a, b : natural ) return natural;


end package MathLib;


---------------------------------------------------------------------------------------------
-- PACKAGE'S BODY
---------------------------------------------------------------------------------------------
package body MathLib is

---------------------------------------------------------------------------------------
-- log2(n)
--  function returns how many bits is neccesary to show value n
--	2 -> 2
--	3 -> 2
--	4 -> 3
--	7 -> 3
function log2 ( n : natural ) return natural is
	variable 	t	: natural;
	variable	i	: natural;
begin
	i := 1;
	t := 2;
	while n >= t loop
		t := 2 * t;
		i := i + 1;
	end loop;
	return i;
end log2;

---------------------------------------------------------------------------------------
-- min(a, b)
--  function returns lowest from values a and b
function min ( a, b : natural ) return natural is
begin
	if a > b then
		return b;
	else
		return a;
	end if;
end min;

---------------------------------------------------------------------------------------
-- max(a, b)
--  function returns bigger from values a and b
function max ( a, b : natural ) return natural is
begin
	if a < b then
		return b;
	else
		return a;
	end if;
end max;


end MathLib;
